%%  alignByCOMx %%

%%align 2D input along horizontal direction using center of mass
%%inputs:
%%  in - input 2D image

%%outputs:
%%  imgOut - aligned image
%%  shiftX  -  applied shift to align image

%% Author: AJ Pryor
%% Jianwei (John) Miao Coherent Imaging Group
%% University of California, Los Angeles
%% Copyright (c) 2015. All Rights Reserved.

function [imgOut shiftX] = alignByCOMx(in)

[dimy dimx, dimz] = size(in);
if mod(dimx,2)==0
    centerX = (dimx/2)+1;
else
    centerX = round((dimx/2));
end

COMx = round(sum(sum(in,1).*(1:dimx))./sum(sum(in(:))));
shiftX = centerX-COMx;
imgOut = circshift(in,[0 shiftX 0]);
