%%  alignByCOMy %%

%%align 2D input along vertical direction using center of mass
%%inputs:
%%  in - input 2D image

%%outputs:
%%  imgOut - aligned image
%%  shiftY  -  applied shift to align image

%% Author: AJ Pryor
%% Jianwei (John) Miao Coherent Imaging Group
%% University of California, Los Angeles
%% Copyright (c) 2015. All Rights Reserved.

function [imgOut shiftY] = alignByCOMy(in)

[dimy dimx] = size(in);
if mod(dimy,2)==0
    centerY = (dimy/2)+1; 
else
    centerY = round((dimy/2));
end

COMy = round(sum(sum(in,2).*(1:dimy)')./sum(sum(in)));
shiftY = centerY-COMy;

imgOut = circshift(in,[shiftY 0 0]);