function [symmetrizedKX,symmetrizedKY,symmetrizedKZ, symmetrizedSetOfPatterns] = applySymmetryOperations(diffractionPatterns,symmetryOperations,measuredX,measuredY,measuredZ);

numberOfDiffractionPatterns = size(diffractionPatterns,3);
numberOfSymmetryOperations = size(symmetryOperations,3);

symmetrizedKX = zeros(size(diffractionPatterns,1)*size(diffractionPatterns,2),numberOfSymmetryOperations,numberOfDiffractionPatterns);
symmetrizedKY = zeros(size(diffractionPatterns,1)*size(diffractionPatterns,2),numberOfSymmetryOperations,numberOfDiffractionPatterns);
symmetrizedKZ = zeros(size(diffractionPatterns,1)*size(diffractionPatterns,2),numberOfSymmetryOperations,numberOfDiffractionPatterns);
symmetrizedSetOfPatterns = zeros(size(diffractionPatterns,1)*size(diffractionPatterns,2),numberOfSymmetryOperations,numberOfDiffractionPatterns);

for diffractionPatternNumber = 1:numberOfDiffractionPatterns
    kx = measuredX(:,:,diffractionPatternNumber);kx = kx(:)';
    ky = measuredY(:,:,diffractionPatternNumber);ky = ky(:)';
    kz = measuredZ(:,:,diffractionPatternNumber);kz = kz(:)';
    currentDiffractionPattern = diffractionPatterns(:,:,diffractionPatternNumber);
    for symmetryOperationNumber = 1:numberOfSymmetryOperations
    symmetrizedCoordinates = symmetryOperations(:,:,symmetryOperationNumber)*[kx;ky;kz];
    symmetrizedKX(:,symmetryOperationNumber,diffractionPatternNumber) = symmetrizedCoordinates(1,:);
    symmetrizedKY(:,symmetryOperationNumber,diffractionPatternNumber) = symmetrizedCoordinates(2,:);
    symmetrizedKZ(:,symmetryOperationNumber,diffractionPatternNumber) = symmetrizedCoordinates(3,:);
    symmetrizedSetOfPatterns(:,symmetryOperationNumber,diffractionPatternNumber) = currentDiffractionPattern(:);
    end
end

symmetrizedKX = symmetrizedKX(:)';
symmetrizedKY = symmetrizedKY(:)';
symmetrizedKZ = symmetrizedKZ(:)';
symmetrizedSetOfPatterns = symmetrizedSetOfPatterns(:)';


