function [correctedPattern, dOmega] = correctIntensitiesForSolidAngle(diffractionPattern, sampleToDetectorDistance, detectorPixelSize)
[dimx, dimy] = size(diffractionPattern);
ncx = round((dimx+1)/2);
ncy = round((dimy+1)/2);
[xx, yy] = meshgrid(detectorPixelSize * ((1:dimx)-ncx) ,detectorPixelSize * ((1:dimy)-ncy) );
dOmega = abs(sampleToDetectorDistance*detectorPixelSize*detectorPixelSize ./ (xx.^2 + yy.^2 + sampleToDetectorDistance.^2)^(3/2));
dOmega = dOmega ./ max(dOmega(:));
correctedPattern = diffractionPattern ./ dOmega;
end